<?php
/**
* Joomla MusicBox  2.0.0
* @ Released under GNU/GPL License: http://www.gnu.org/copyleft/gpl.html
* @paked: musicbox.class.php
* @ Copyright (C) 2007 Vamba
* @ All rights reserved
**/


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
Error_Reporting(E_ALL & ~E_NOTICE);

/**
* Category database table class
* @package Joomla
*/
class mosCategories extends mosDBTable {
	var $id					= null;
	var $parent_id			= null;
	var $title				= null;
	var $name				= null;
	var $image				= null;
	var $section			= null;
	var $image_position		= null;
	var $description		= null;
	var $published			= null;
	var $checked_out		= null;
	var $checked_out_time	= null;
	var $ordering			= null;
	var $access				= null;
	var $params				= null;

	/**
	* @param database A database connector object
	*/
	function mosCategories( &$db ) {
		$this->mosDBTable( '#__categories', 'id', $db );
	}
	// overloaded check function
	function check() {
		// check for valid name
		if (trim( $this->title ) == '') {
			$this->_error = _MBOX_CLS_CATTITLE ;
			return false;
		}
		if (trim( $this->name ) == '') {
			$this->_error = _MBOX_CLS_CATNAME ;
			return false;
		}

		// check for existing name
		$query = "SELECT id"
		. "\n FROM #__categories "
		. "\n WHERE name = " . $this->_db->Quote( $this->name )
		. "\n AND section = " . $this->_db->Quote( $this->section )
		;
		$this->_db->setQuery( $query );

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _MBOX_CLS_CATNAMEALREADY ;
			return false;
		}
		return true;
	}
}

/**
* MusicBox_Tools table class
* @package MusicBox
*/
class MusicBox_tools
{
    function categoryArray() {
        global $database;
		//query
        $query = "SELECT c.*, c.parent_id AS parent"
         . "\n FROM #__categories c"
         . "\n WHERE section='com_musicbox'"
         . "\n AND published <> -2"
         . "\n ORDER BY ordering" ;
        $database->setQuery($query);
        $items = $database->loadObjectList();

        $children = array();

        foreach ($items as $v) {
            $pt = $v->parent;
            $list = @$children[$pt] ? $children[$pt] : array();
            array_push($list, $v);
            $children[$pt] = $list;
        }
        $array = mosTreeRecurse(0, '', array(), $children);
        return $array;
    }
	
}

class HTML extends mosHTML {

    function categoryList($id, $action, $options = array()) {
        $list = MusicBox_tools::categoryArray();

        foreach ($list as $item) {
            $options[] = mosHTML::makeOption($item->id, $item->treename);
        }
        $parent = mosHTML::selectList($options, 'catid', 'id="catid" class="inputbox" size="1" onchange="' . $action . '"', 'value', 'text', $id);
        return $parent;
    }

    function categoryParentList($id, $action, $options = array()) {
        global  $database;
        $list = MusicBox_tools::categoryArray();
        $cat = new mosCategories($database);
        $cat->load($id);

        $this_treename = '';
        foreach ($list as $item) {
            if ($this_treename) {
                if ($item->id != $cat->id && strpos($item->treename, $this_treename) === false) {
                    $options[] = mosHTML::makeOption($item->id, $item->treename);
                }
            } else {
                if ($item->id != $cat->id) {
                    $options[] = mosHTML::makeOption($item->id, $item->treename);
                } else {
                    $this_treename = "$item->treename/";
                }
            }
        }

        $parent = mosHTML::selectList($options, 'parent_id', 'class="inputbox" size="1"', 'value', 'text', $cat->parent_id);
        return $parent;
    }

    function imageList($name, &$active, $javascript = null, $directory = null) {
        global $mosConfig_absolute_path;

        if (!$javascript) {
            $javascript = "onchange=\"javascript:if (document.adminForm." . $name . ".options[selectedIndex].value!='') {document.imagelib.src='../images/stories/' + document.adminForm." . $name . ".options[selectedIndex].value} else {document.imagelib.src='../images/blank.png'}\"";
        }
        if (!$directory) {
            $directory = '/images/stories';
        }

        $imageFiles = mosReadDirectory($mosConfig_absolute_path . $directory);
        $images = array(mosHTML::makeOption('', _MBOX_SELECT_IMAGE));
        foreach ($imageFiles as $file) {
            if (eregi("bmp|gif|jpg|png", $file)) {
                $images[] = mosHTML::makeOption($file);
            }
        }
        $images = mosHTML::selectList($images, $name, 'id="'.$name.'" class="inputbox" size="1" ' . $javascript, 'value', 'text', $active);

        return $images;
    }
}

/**
* MusicBox mosAlbums table class
* @package MusicBox
*/
class mosAlbum extends mosDBTable {

	var $id=null;
	var $title=null;
	var $titleifsingle=null;	
	var $etichetta=null;
	var $catid=null;
	var $anno=null;
	var $durata=null;
	var $html=null;
	var $editor=null;
	var $editorhtml=null;
	var $idauthors=null;
	var $hits=null;
	var $catalog=null;	
	var $date=null;
	var $country=null;
	var $country2=null;	
	var $support=null;
	var $support2=null;	
	var $box=null;
	var $box2=null;	
	var $typedisc=null;
	var $typedisc2=null;	
	var $published=null;
	var $google=null;
	var $amazon=null;	
	var $cloud=null;	
	var $galleria=null;
	var $foto=null;		
	var $custom01=null;	
	var $custom02=null;	
	var $custom03=null;	
	var $custom04=null;	
	var $custom05=null;	
	var $custom06=null;		
	var $created=null;
	var $created_by=null;
	var $created_by_alias=null;
	var $modified=null;
	var $modified_by=null;
	var $checked_out=null;
	var $checked_out_time=null;
	var $publish_up=null;
	var $publish_down=null;
	var $ordering=null;
	var $metakey=null;
	var $metadesc=null;
	var $access=null;

	function mosAlbum( &$db ) {
		$this->mosDBTable( '#__musicboxalbum', 'id', $db );
	}

	function check() {

		if (trim( $this->title ) == '') {
			$this->_error = _MBOX_INSERT_TITLE;
			return false;
		}

		//query
		$this->_db->setQuery( "SELECT id FROM #__musicboxalbum"
		. "\nWHERE title='$this->title' AND catid='$this->catid'"
		);

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _MBOX_INSERT_TITLE_EXIST;
			return false;
		}
		return true;
	}

}

/**
* MusicBox mosAuth table class
* @package MusicBox
*/
class mosAuth extends mosDBTable {


	var $id=null;
	var $name=null;
	var $country=null;
	var $country2=null;	
	var $dborn=null;
	var $city=null;	
	var $award=null;	
	var $nalbum=null;	
	var $nsingle=null;
	var $html=null;
	var $foto=null;
	var $galleria=null;	


	function mosAuth( &$db ) {
		$this->mosDBTable( '#__musicboxsinger', 'id', $db );
	}

	function check() {

		if (trim( $this->name ) == '') {
			$this->_error = _MBOX_SINGER_NAME;
			return false;
		}

		//query
		$this->_db->setQuery( "SELECT id FROM #__musicboxsinger "
		. "\nWHERE name='$this->name'"
		);

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _MBOX_SINGER_NAME_EXIST;
			return false;
		}
		return true;
	}

}

/**
* MusicBox mosEditor table class
* @package MusicBox
*/
class mosEditor extends mosDBTable {

	var $id=null;
	var $name=null;
	var $html=null;



	function mosEditor( &$db ) {
		$this->mosDBTable( '#__musicboxfirm', 'id', $db );
	}

	function check() {
		if (trim( $this->name ) == '') {
			$this->_error = _MBOX_FIRM_NAME_INSERT;
			return false;
		}
		//query
		$this->_db->setQuery( "SELECT id FROM #__musicboxfirm "
		. "\nWHERE name='$this->name' "
		);

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _MBOX_FIRM_NAME_EXIST;
			return false;
		}
		return true;
	}
}

/**
* MusicBox mosCanzone table class
* @package MusicBox
*/
class mosCanzone extends mosDBTable {


	var $id=null;
	var $albumid=null;
	var $song=null;
	var $songurl=null;	
	var $songmp3=null;
	var $songext=null;	
	var $video=null;	
	var $videosfonte=null;
	var $videoalternativo=null;
	var $liric=null;	
	var $ordering=null;	
	var $published=null;	
	var $publish_up=null;
	var $publish_down=null;

	function mosCanzone( &$db ) {
		$this->mosDBTable( '#__musicboxsong', 'id', $db );
	}

	function check() {

		if (trim( $this->song ) == '') {
			$this->_error = _MBOX_SONG_NAME;
			return false;
		}

		//query
		$this->_db->setQuery( "SELECT id FROM #__musicboxsong "
		. "\nWHERE song='$this->song'"
		);

		return true;
	}
}

/**
* MusicBox mosMusicboxlinks table class
* @package MusicBox
*/

class mosMusicboxlinks extends mosDBTable {
	var $id=null;
	var $albumlink=null;
	var $link=null;
	var $target=null;
	var $counter=null;


	function mosMusicboxlinks( &$db ) {
		$this->mosDBTable( '#__musicboxlinks', 'id', $db );
	}
}

/**
* MusicBox mosHit table class
* @package MusicBox
*/
class mosHit extends mosDBTable {


	var $id=null;
	var $nomehit=null;	
	var $ordering=null;	
	var $published=null;	
	var $publish_up=null;
	var $publish_down=null;
	var $created=null;
	var $created_by=null;
	var $created_by_alias=null;
	var $modified=null;
	var $modified_by=null;
	var $checked_out=null;
	var $checked_out_time=null;	

	function mosHit ( &$db ) {
		$this->mosDBTable( '#__musicboxhit', 'id', $db );
	}
	
	function check() {
		if (trim( $this->nomehit ) == '') {
			$this->_error = _MBOX_FIRM_NAME_INSERT;
			return false;
		}
		//query
		$this->_db->setQuery( "SELECT id FROM #__musicboxhit "
		. "\nWHERE nomehit='$this->nomehit' "
		);

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _MBOX_FIRM_NAME_EXIST;
			return false;
		}
		return true;
	}	
}	

/**
* MusicBox mosSonghit table class
* @package MusicBox
*/
class mosSonghit extends mosDBTable {


	var $id=null;
	var $hitid=null;	
	var $songhit=null;
	var $artisthit=null;
	var $imagehit=null;	
	var $videofontehit=null;	
	var $videohit=null;	
	var $videoaltenativohit=null;		
	var $ordering=null;
	var $published=null;	

	function mosSonghit( &$db ) {
		$this->mosDBTable( '#__musicboxsonghit', 'id', $db );
	}
}

/**
* MusicBox mosAlbums table class
* @package MusicBox
*/
class mosLyric extends mosDBTable {

	var $id=null;
	var $albumid=null;	
	var $titolo=null;
	var $lyric=null;
	var $ordering=null;
	var $published=null;	

	function mosLyric( &$db ) {
		$this->mosDBTable( '#__musicboxlyric', 'id', $db );
	}
}
?>